<template>
	<mobile-frame>
		<view class="main">
			<scroll-view scroll-y="true" class="scroll-view" @scrolltolower="toPage" @scroll="toScroll">
				<view class="list-scroll-view">
					<view class="one">
						<rich-text :nodes="info.content.value"></rich-text>
					</view>
					<view class="two">
						<view class="list" v-for="(item,index) in list" :key="index" @tap="toBuy(item)">
							<view class="img">
								<image class="image" :src="item.goods.file&&item.goods.file.length?item.goods.file[0].url:''" mode=""></image>
							</view>
							<view class="name">
								<text>{{item.goods.name}}</text>
							</view>
							<view class="money">
								<view class="money_1">
									<text>¥</text><text>{{item.sell_money||0}}</text>
								</view>
								<view class="money_2">
									<text>¥</text><text>{{item.flow_money||0}}</text>
								</view>
							</view>
						</view>
					</view>
					<view class="is_bottom" v-if="is_bottom">
						<text>{{config.bottom_title}}</text>
					</view>
				</view>
			</scroll-view>
		</view>
	</mobile-frame>
</template>

<script>
	export default {
		components: {},
		data() {
			return {
				// 系统设置
				config: {},
				id: '',
				// 详情
				info: {},
				// 商品列表
				list: [],
				total: 0,
				page: 0,
				skip: 0,
				limit: 10,
				// 数据是否触底
				is_bottom: false,
				scrollTop: 0,
			};
		},
		onLoad: async function(e) {
			const that = this;
			that.$set(that, `id`, e.id || '');
			that.searchConfig();
			await that.searchAct();
			await that.configShare();
		},
		methods: {
			// 查询基本设置
			searchConfig() {
				const that = this;
				uni.getStorage({
					key: 'config',
					success: function(res) {
						if (res.data) that.$set(that, `config`, res.data)
					},
					fail: function(err) {
						console.log(err);
					}
				})
			},
			async searchAct() {
				const that = this;
				// 查询详情
				let res = await that.$api(`/platformAct/${that.id}`, 'GET');
				if (res.errcode == '0') {
					uni.setNavigationBarTitle({
						title: res.data.act_time.title
					});
					if (res.data.content.value) res.data.content.value = res.data.content.value.replace(/\<img/gi, '<img class="rich-img"');
					that.$set(that, `info`, res.data);
					that.search()
				}
			},
			async search() {
				const that = this;
				// 查询商品列表
				let info = {
					skip: that.skip,
					limit: that.limit,
					platformAct: that.id
				}
				let res = await that.$api(`/goodsJoinAct`, 'GET', {
					...info,
				})
				if (res.errcode == '0') {
					let list = [...that.list, ...res.data];
					that.$set(that, `list`, list)
					that.$set(that, `total`, res.total)
				}
			},
			toPage() {
				const that = this;
				let list = that.list;
				let limit = that.limit;
				if (that.total > list.length) {
					uni.showLoading({
						title: '加载中',
						mask: true
					})
					let page = that.page + 1;
					that.$set(that, `page`, page)
					let skip = page * limit;
					that.$set(that, `skip`, skip)
					that.search();
					uni.hideLoading();

				} else that.$set(that, `is_bottom`, true)
			},
			toScroll(e) {
				const that = this;
				let up = that.scrollTop;
				that.$set(that, `scrollTop`, e.detail.scrollTop);
				let num = Math.sign(up - e.detail.scrollTop);
				if (num == 1) that.$set(that, `is_bottom`, false);
			},
			// 购买
			toBuy(e) {
				const that = this;
				uni.navigateTo({
					url: `/pagesHome/order/detail?id=${e.goods._id}`
				})
			},
			// 清空列表
			clearPage() {
				const that = this;
				that.$set(that, `list`, [])
				that.$set(that, `skip`, 0)
				that.$set(that, `limit`, 6)
				that.$set(that, `page`, 0)
			},
			// 配置分享内容
			configShare() {
				const that = this;
				let info = that.info;
				let imageUrl = that.config.config.logo[0].url;
				if (info.share.length > 0) imageUrl = info.share[0].url;
				that.$config.share = {
					title: info.act_time.title,
					path: `/pagesRest/activity/info?id=${that.id}`,
					imageUrl: imageUrl
				}
			}
		}
	}
</script>

<style lang="scss">
	.main {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.one {
			padding: 2vw;

			.rich-img {
				width: 100% !important;
				display: block;
			}
		}

		.two {
			display: flex;
			flex-wrap: wrap;
			padding: 2vw;

			.list {
				padding: 2vw;
				background-color: var(--f1Color);
				margin: 0 2vw 2vw 0;
				border-radius: 5px;
				width: 43vw;

				.img {
					.image {
						width: 100%;
						height: 30vh;
						border-radius: 5px;
					}
				}

				.name {
					margin: 0 0 1vw 0;

					text {
						font-size: var(--font14Size);
					}
				}

				.money {
					display: flex;

					.money_1 {
						color: var(--fFB1Color);
						font-size: 12px;

						text:last-child {
							font-size: 16px;
							padding: 0 0 0 1vw;
						}
					}

					.money_2 {
						font-size: 12px;
						margin: 0 0 0 2vw;
						color: var(--f99Color);

						text {
							text-decoration: line-through;
						}

						text:last-child {
							font-size: 16px;
							padding: 0 0 0 1vw;
						}
					}
				}
			}

			.list:nth-child(2n) {
				margin: 0 0 2vw 0;
			}
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			flex-direction: column;
		}
	}

	.is_bottom {
		text-align: center;
		width: 100vw;

		text {
			padding: 2vw 0;
			display: inline-block;
			color: #858585;
			font-size: 14px;
		}
	}
</style>
